**********************************************************
*  TEST.ASM                                              *
*  PROGRAM USED TO TEST EMULATOR                         *
*                                                        *
**********************************************************
*  
* SYSTEM CONSTANTS
*
STRTPRG   EQU  $C800          START OF TARGET PROGRAM ROM     
TARGRAM   EQU  $A780          START OF TARGET RAM
ENDRAM    EQU  $A7FF          END OF TARGET RAM     
*
* 6321 CONSTANTS
*
PEREGA    EQU  $0             PERIPHERAL REG. A
DDRA      EQU  $0             DATA DIRECTION REG. A
CONTA     EQU  $1             CONTROL REG. A
PEREGB    EQU  $2             PERIPHERAL REG. B
DDRB      EQU  $2             DATA DIRECTION REG. B
CONTB     EQU  $3             CONTROL REG. B
A6321     EQU  $4000          BASE ADDRESS 
B6321     EQU  $6000          BASE ADDRESS 
*
*
* SYSTEM VARIABLES
*
          ORG  TARGRAM        START OF RAM
TEMP      RMB  1              
          ORG  STRTPRG
*         LDS  
*
* MAIN LINE PROGRAM BEGINS HERE.
*
MAIN      LDAB #$00           SELECT DDRA PORT 1
          STAB CONTA+A6321
          LDAA #$FF           SET PORT 1 TO ALL OUTPUTS
          STAA DDRA+A6321
          LDAA #$04           SELECT CONTROLA
          STAA CONTA+A6321
          CLRA
COUNT     STAA PEREGA+A6321
          DECA
          JMP  COUNT
*
* INVALID INTERRUPT REQUEST
*
INVALID_IRQ    RTI            EXIT
*
* INTERRUPT VECTOR TABLE 
* 
          ORG  $CFF0  
          FDB  INVALID_IRQ     SERIAL COMMUNICATION INTERFACE
          FDB  INVALID_IRQ     TIMER OVERFLOW
          FDB  INVALID_IRQ     OUTPUT COMPARE
          FDB  INVALID_IRQ     INPUT CAPTURE 
          FDB  INVALID_IRQ     IRQ1
          FDB  INVALID_IRQ     SWI 
          FDB  INVALID_IRQ     NMI 
          FDB  MAIN            RESET 
          END

